" Basics
set t_Co=256        " Use 256 colors
set encoding=utf8   " Use utf-8 encoding
set nocompatible    " Get out of vi-compatible mode
set background=dark " I am using a dark background
" set background=light " I am using a dark background
syntax on           " Syntax highlighting on

" General
"colorscheme solarized
colorscheme wombat
"colorscheme PaperColor
" setlocal spell spelllang=en_us
set fileformats=unix,dos,mac    " support all three, in this order
set nostartofline               " leave my cursor where it was
set history=10000
set autoread        " Set to auto read when a file is changed from the outside
set autochdir       " Change current directory to be directory of current file
set colorcolumn=81
"set foldmethod=syntax

" Have tab complete work more like bash
set wildmenu
set wildmode=list:longest
set backspace=start,eol,indent
set whichwrap+=<,>,[,]
set magic       "Set magic on, for regular expressions

" Turn on omni completion. Must have `filetype plugin on` to use.
" To use, in insert mode press ctrl+x ctrl+o
set omnifunc=syntaxcomplete#Complete

" Tabs
set expandtab       " expandtab converts tabs to spaces. For tabs, set noexpandtab
set shiftwidth=4    " unify
set softtabstop=4   " Pressing backspace works like tabs
set tabstop=4       " real tabs should be 4, but they will show with set list on

" Indent
set autoindent      "Auto indent
set smartindent     "Smart indent
set copyindent      " above all -- follow the conventions laid before us
set preserveindent  " above all -- follow the conventions laid before us
set shiftround      " when at 3 spaces, and I hit '>', go to 4, not 5
filetype plugin on   " load filetype plug-ins and indent settings
filetype indent on   " load filetype plug-ins and indent settings

" UI
set showcmd         " show the command being typed
set ruler           " Always show current positions along the bottom
set number relativenumber  " Use relative line numbers
set numberwidth=4   " If we have over 9999 lines
set hidden          " you can change buffer without saving
"set mouse=a         " use mouse everywhere

" No sound on errors
set noerrorbells
set novisualbell
"visual bell
set t_vb=
set tm=500

" Visual Cues
set showmatch       " show matching brackets
set matchtime=2     " how many tenths of a second to blink matching brackets for
set hlsearch        " highlight searched for phrases
set incsearch       " BUT do highlight as you type you search phrase
set scrolloff=5     " Keep 5 lines (top/bottom) for scope
set sidescrolloff=5 " Keep 5 lines at the size
set list        " we do what to show tabs, to ensure we get them out of my files
set listchars=tab:\ \ ,trail:… " show tabs and trailing whitespace

" Status
" ~\file[+] [type] [line,column] [number of lines]
set statusline=%F%m%r%h%w\ [%Y]\ [%03l,%03v]\ [%L]
set laststatus=2 " always show the status line

" Text Formatting/Layout
set nowrap      " do not wrap line
set ignorecase  " case insensitive by default
set smartcase   " if there are caps, go case-sensitive
set completeopt=menu,longest,preview " improve the way autocomplete works
